import { AfterViewInit, ChangeDetectorRef, ElementRef, EventEmitter, OnInit, Provider, Renderer2 } from '@angular/core';
import { ControlContainer, ControlValueAccessor, FormControl, FormControlDirective } from '@angular/forms';
import { NgIMaskConfig } from '../../interfaces/ng-imask-config.interface';
import { IMaskCurrencyServiceReturn } from '../../interfaces/ng-mask-service-return.interface';
import { NgMaskAmountService } from '../../services/masks/ng-mask-amount.service';
import { NgMaskCurrencyService } from '../../services/masks/ng-mask-currency.service';
import { NgMaskPercentService } from '../../services/masks/ng-mask-percent.service';
import { NgMaskService } from '../../services/masks/ng-mask.service';
import { NgIconConfig, NgIconPositionsConfig } from '../../interfaces/ng-icon-config.interface';
import { NgConfigService } from '../../config/ng-config.service';
import { Observable } from 'rxjs';
export declare const PROVIDER_VALUE_ACCESSOR: Provider;
export declare class NgAutocompleteComponent implements OnInit, AfterViewInit, ControlValueAccessor {
    private _controlContainer;
    private renderer2;
    private ngMaskCurrencyService;
    private ngMaskPercentService;
    private ngMaskAmountService;
    private ngMaskService;
    private ngInputConfig;
    private changeDetectorRef;
    formControlDirective: FormControlDirective;
    inputRef: ElementRef<HTMLInputElement>;
    formControl: FormControl;
    formControlName: string;
    loading: boolean;
    funcSearch: (value: any) => Promise<any> | Observable<any>;
    debounceTimeMenuClose: number;
    debounceTimeEventInput: number;
    propLabel: string;
    propReturn: null | string;
    showContentIsEmpty: boolean;
    _dropdownIsOpen: boolean;
    _indexSelect: number | null;
    _indexFocus: number | null;
    set options(value: any[]);
    _options: any;
    id: string;
    label: string;
    type: string;
    readonly: boolean;
    disabled: boolean;
    set placeholder(text: string | null);
    _placeholder?: string | null;
    help: string;
    required: boolean;
    icon: NgIconPositionsConfig;
    mask: NgIMaskConfig | string;
    size: 'lg' | 'md' | 'sm';
    set errors(errors: {
        [key: string]: string;
    });
    _errors: {
        [key: string]: string;
    };
    _errorsKeys: string[];
    _maskRef: IMaskCurrencyServiceReturn;
    get control(): FormControl;
    constructor(_controlContainer: ControlContainer, renderer2: Renderer2, ngMaskCurrencyService: NgMaskCurrencyService, ngMaskPercentService: NgMaskPercentService, ngMaskAmountService: NgMaskAmountService, ngMaskService: NgMaskService, ngInputConfig: NgConfigService, changeDetectorRef: ChangeDetectorRef);
    ngOnInit(): void;
    ngAfterViewInit(): void;
    handleClickIcon(event: Event, input: HTMLInputElement, icon: NgIconConfig | undefined, position: 'left' | 'right'): void;
    debounceTimeBlur: any;
    blur: EventEmitter<any>;
    handleBlur(event: FocusEvent, index?: number): void;
    focus: EventEmitter<any>;
    handleFocus(event: FocusEvent): void;
    handleInput(event: KeyboardEvent): void;
    handleSaveValue(value?: HTMLElement | string | number): void;
    debounceTimeInput: any;
    inputDebounce: EventEmitter<any>;
    handleInputDebounce(value?: any): void;
    handleOpenMenu(event?: Event): void;
    handleCloseMenu(event?: Event): void;
    handleSearch(value: any): Promise<void>;
    handleSelect(index: number): void;
    handleChange: (_: any) => void;
    handleTouched: () => void;
    registerOnTouched: (fn: () => void) => () => void;
    setDisabledState: (isDisabled: boolean) => boolean;
    registerOnChange: (fn: (_: any) => void) => (_: any) => void;
    writeValue: (value: number | string) => void;
}
