import { AfterViewInit, ChangeDetectorRef, ElementRef, EventEmitter, OnInit, Provider, Renderer2 } from '@angular/core';
import { ControlContainer, ControlValueAccessor, FormControl, FormControlDirective } from '@angular/forms';
import { NgIMaskConfig } from '../../interfaces/ng-imask-config.interface';
import { NgMaskConfig } from '../../interfaces/ng-mask-config.interface';
import { IMaskCurrencyServiceReturn } from '../../interfaces/ng-mask-service-return.interface';
import { NgMaskAmountService } from '../../services/masks/ng-mask-amount.service';
import { NgMaskCurrencyService } from '../../services/masks/ng-mask-currency.service';
import { NgMaskPercentService } from '../../services/masks/ng-mask-percent.service';
import { NgMaskService } from '../../services/masks/ng-mask.service';
import { NgIconConfig, NgIconPositionsConfig } from '../../interfaces/ng-icon-config.interface';
import { NgConfigService } from '../../config/ng-config.service';
import { NgFormatDateByTypeService } from '../../services/utils/ng-format-date-by-type.service';
export declare const PROVIDER_VALUE_ACCESSOR: Provider;
export declare class NgInputComponent implements OnInit, AfterViewInit, ControlValueAccessor {
    private _controlContainer;
    private renderer2;
    private ngMaskCurrencyService;
    private ngMaskPercentService;
    private ngMaskAmountService;
    private ngFormatDateByTypeService;
    private ngMaskService;
    private ngInputConfig;
    private changeDetectorRef;
    formControlDirective: FormControlDirective;
    inputRef: ElementRef<HTMLInputElement>;
    formControl: FormControl;
    formControlName: string;
    id: string;
    label: string;
    type: string;
    readonly: boolean;
    disabled: boolean;
    set placeholder(text: string | null);
    _placeholder?: string | null;
    help: string;
    required: boolean;
    amount: NgMaskConfig;
    percent: NgMaskConfig;
    currency: NgMaskConfig;
    length: string | number;
    icon: NgIconPositionsConfig;
    mask: NgIMaskConfig | string;
    size: 'lg' | 'md' | 'sm';
    date: Date | string;
    fill: boolean;
    set errors(errors: {
        [key: string]: string;
    });
    _errors: {
        [key: string]: string;
    };
    _errorsKeys: string[];
    _maskRef: IMaskCurrencyServiceReturn;
    get control(): FormControl;
    constructor(_controlContainer: ControlContainer, renderer2: Renderer2, ngMaskCurrencyService: NgMaskCurrencyService, ngMaskPercentService: NgMaskPercentService, ngMaskAmountService: NgMaskAmountService, ngFormatDateByTypeService: NgFormatDateByTypeService, ngMaskService: NgMaskService, ngInputConfig: NgConfigService, changeDetectorRef: ChangeDetectorRef);
    ngOnInit(): void;
    ngAfterViewInit(): void;
    formatDate(value: any): string;
    handleClickIcon(event: Event, input: HTMLInputElement, icon: NgIconConfig | undefined, position: 'left' | 'right'): void;
    blur: EventEmitter<any>;
    handleBlur(event: FocusEvent): void;
    focus: EventEmitter<any>;
    handleFocus(event: FocusEvent): void;
    handleInput(value?: HTMLElement | string | number): void;
    handleChange: (_: any) => void;
    handleTouched: () => void;
    registerOnTouched: (fn: () => void) => () => void;
    setDisabledState: (isDisabled: boolean) => boolean;
    registerOnChange: (fn: (_: any) => void) => (_: any) => void;
    writeValue: (value: number | string) => void;
}
