import { ChangeDetectorRef, ElementRef, EventEmitter, OnInit, Provider, Renderer2 } from '@angular/core';
import { ControlContainer, FormControl, FormControlDirective, SelectControlValueAccessor } from '@angular/forms';
import { NgConfigService } from '../../config/ng-config.service';
import { NgIconConfig, NgIconPositionsConfig } from '../../interfaces/ng-icon-config.interface';
export declare const PROVIDER_VALUE_ACCESSOR: Provider;
export interface NgSelectOptions {
    position?: 'start' | 'end';
    propLabel?: string | string[];
    propValue?: string | string[];
    propCompare?: string | string[];
    options: NgSelectOptionItem[];
}
export interface NgSelectOptionItem {
    label?: string;
    value?: any;
    [key: string]: any;
}
export declare class NgSelectComponent extends SelectControlValueAccessor implements OnInit {
    private _controlContainer;
    private renderer2;
    private ngInputConfig;
    private changeDetectorRef;
    formControlDirective: FormControlDirective;
    selectRef: ElementRef<HTMLSelectElement>;
    formControl: FormControl;
    formControlName: string;
    id: string;
    label: string;
    type: string;
    readonly: boolean;
    disabled: boolean;
    help: string;
    required: boolean;
    icon: NgIconPositionsConfig;
    propLabel: string;
    propValue: string;
    propCompare: string;
    size: 'lg' | 'md' | 'sm';
    position: 'start' | 'end';
    set options(options: NgSelectOptionItem[]);
    _options: NgSelectOptionItem[];
    set errors(errors: {
        [key: string]: string;
    });
    _errors: {
        [key: string]: string;
    };
    _errorsKeys: string[];
    get control(): FormControl;
    constructor(_controlContainer: ControlContainer, renderer2: Renderer2, ngInputConfig: NgConfigService, elementRef: ElementRef<any>, changeDetectorRef: ChangeDetectorRef);
    ngOnInit(): void;
    handleCompareWith(itemOne: any, itemTwo: any): boolean;
    handleClickIcon(event: Event, select: HTMLSelectElement, icon: NgIconConfig | undefined, position: 'left' | 'right'): void;
    focus: EventEmitter<any>;
    handleFocus(event: FocusEvent): void;
    handleInput(value?: HTMLElement | string | number): void;
    handleChange: (_: any) => void;
    setDisabledState: (isDisabled: boolean) => boolean;
    registerOnChange: (fn: (_: any) => void) => (_: any) => void;
    writeValue: (value: number | string) => void;
}
