import { ChangeDetectorRef, ElementRef, Renderer2, OnInit, Provider, EventEmitter } from '@angular/core';
import { ControlValueAccessor } from '@angular/forms';
import { NgMaskConfig } from '../../interfaces/ng-mask-config.interface';
export declare const PROVIDER_VALUE_ACCESSOR: Provider;
export declare class NgMaskAmountDirective implements OnInit, ControlValueAccessor {
    private elementRef;
    private renderer2;
    private changeDetectorRef;
    private _inputRef;
    private _isAmount;
    private _config;
    set ngMaskAmount(config: NgMaskConfig | string);
    type: string;
    value: EventEmitter<any>;
    constructor(elementRef: ElementRef<HTMLInputElement>, renderer2: Renderer2, changeDetectorRef: ChangeDetectorRef);
    ngOnInit(): void;
    createMask(): void;
    formatAmount(value: string | number, data?: string | null): {
        valueFormat: string;
        value: number;
    };
    onTouched: () => void;
    onFocus: () => void;
    eventTime: any;
    onInput(value?: InputEvent | string | number): void;
    validRequired(value: string | number): any;
    onChange: (_: any) => void;
    registerOnTouched: (fn: () => void) => () => void;
    setDisabledState: (isDisabled: boolean) => void;
    registerOnChange: (fn: (_: any) => void) => void;
    writeValue(value: number | string): void;
}
